package biomorphs;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;

public class Dawkins extends JApplet {
    
    private Genome biomorph = new Genome();
    
    private JLabel lblParent;
    private JLabel lblGene1;
    private JLabel lblGene2;
    private JLabel lblGene3;
    private JLabel lblGene4;
    private JLabel lblGene5;
    private JLabel lblGene6;
    private JLabel lblGene7;
    private JLabel lblGene8;
    private JLabel lblGene9;
    
    private JLabel parentInfo;
    private JLabel childInfo;
    private JTextField parentGenes;
    private JTextField childGenes;
    
    private JTextField gene1Value;
    private JTextField gene2Value;
    private JTextField gene3Value;
    private JTextField gene4Value;
    private JTextField gene5Value;
    private JTextField gene6Value;
    private JTextField gene7Value;
    private JTextField gene8Value;
    private JTextField gene9Value;
    
    private BiomorphPanel geneInc[] = new BiomorphPanel[biomorph.getNoOfGenes()];
    private BiomorphPanel geneDec[] = new BiomorphPanel[biomorph.getNoOfGenes()];
    private BiomorphPanel parent;

    private JTable tabParent;
    private String[][] dataParent = {
        {"","","","","","","","",""}
    };
    
    private JTable tabChild;
    private String[][] dataChild = {
        {"","","","","","","","",""}
    };
    
    private JButton reset;
    private JButton random;
    private String[] headerData = {"Gene 1", "Gene 2", "Gene 3", "Gene 4", "Gene 5", "Gene 6", "Gene 7", "Gene 8", "Gene 9"}; 
    
    float h = 0.58055f; float s = 0.2f; float b = 0.9f;
    Color lightBlue = Color.getHSBColor(h,s,b);
    Color lightGreen = new java.awt.Color(236,249,238);
    Color lightOrange = new java.awt.Color(253,207,121);
    javax.swing.border.Border bUnique = javax.swing.BorderFactory.createLineBorder(lightBlue,1);
    
    public void drawGUI() {
        
        for (int i=0; i<biomorph.getNoOfGenes(); i++) {
            try {
                Genome increased = biomorph.clone();
                Genome decreased = biomorph.clone();
                
                increased.increaseGene(i);
                decreased.decreaseGene(i);
                
                geneInc[i] = new BiomorphPanel(increased);
                geneDec[i] = new BiomorphPanel(decreased);
                
                geneInc[i].setBackground(java.awt.Color.WHITE);
                geneDec[i].setBackground(java.awt.Color.WHITE);
                geneInc[i].setBorder(bUnique);
                geneDec[i].setBorder(bUnique);
                
            } catch (CloneNotSupportedException e) {
                throw new java.lang.IllegalStateException("Genomes could'nt be cloned.");
            }
        }
        
        lblParent = new JLabel("Parent:");
        getContentPane().add(lblParent, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 120, 20));
        
        parent = new BiomorphPanel(biomorph, new java.awt.Color(27,101,32));
        parent.setBackground(lightGreen);
        parent.setBorder(bUnique);
        getContentPane().add(parent, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 20, 120, 120));
        
        parentInfo = new JLabel("Parent genome:");
        getContentPane().add(parentInfo, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 140, 120, 20));
        
        childInfo = new JLabel("Child genome:");
        getContentPane().add(childInfo, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 180, 120, 20));

        tabParent = new JTable(dataParent, headerData); 

        tabParent.setBorder(bUnique);
        tabParent.setGridColor(lightBlue);
        tabParent.setSelectionBackground(lightOrange);
        tabParent.setRowSelectionAllowed(false);
        tabParent.setColumnSelectionAllowed(false);
        setGenomeTable(tabParent, parent.getGenome());
        getContentPane().add(tabParent, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 160, 130, 16));
        
        tabChild = new JTable(dataChild, headerData); 
        
        tabChild.setBorder(bUnique);
        tabChild.setGridColor(lightBlue);
        tabChild.setSelectionBackground(lightOrange);
        tabChild.setRowSelectionAllowed(false);     // important otherwise selection won't function
        tabChild.setColumnSelectionAllowed(true);
        //tabChild.setColumnSelectionInterval(1,1);
        getContentPane().add(tabChild, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 200, 130, 16));        
        
        lblGene9 = new JLabel("Gene 9 (iter.):");
        getContentPane().add(lblGene9, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 260, 120, 20));
        
        getContentPane().add(geneInc[8], new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 280, 120, 120));
        
        getContentPane().add(geneDec[8], new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 400, 120, 120));
        
        lblGene1 = new JLabel("Gene 1 +/-:");
        getContentPane().add(lblGene1, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 0, 120, 20));

        getContentPane().add(geneInc[0], new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 20, 120, 120));
        
        getContentPane().add(geneDec[0], new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 140, 120, 120));
        
        lblGene2 = new JLabel("Gene 2 +/-:");
        getContentPane().add(lblGene2, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 260, 120, 20));
        
        getContentPane().add(geneInc[1], new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 280, 120, 120));
        
        getContentPane().add(geneDec[1], new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 400, 120, 120));
        
        lblGene3 = new JLabel("Gene 3 +/-:");
        getContentPane().add(lblGene3, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 0, 120, 20));

        getContentPane().add(geneInc[2], new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 20, 120, 120));
        
        getContentPane().add(geneDec[2], new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 140, 120, 120));
        
        lblGene4 = new JLabel("Gene 4 +/-:");
        getContentPane().add(lblGene4, new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 260, 120, 20));
        
        getContentPane().add(geneInc[3], new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 280, 120, 120));
        
        getContentPane().add(geneDec[3], new org.netbeans.lib.awtextra.AbsoluteConstraints(270, 400, 120, 120));
        
        lblGene5 = new JLabel("Gene 5 +/-:");
        getContentPane().add(lblGene5, new org.netbeans.lib.awtextra.AbsoluteConstraints(400, 0, 120, 20));

        getContentPane().add(geneInc[4], new org.netbeans.lib.awtextra.AbsoluteConstraints(400, 20, 120, 120));
        
        getContentPane().add(geneDec[4], new org.netbeans.lib.awtextra.AbsoluteConstraints(400, 140, 120, 120));
        
        lblGene6 = new JLabel("Gene 6 +/-:");
        getContentPane().add(lblGene6, new org.netbeans.lib.awtextra.AbsoluteConstraints(400, 260, 120, 20));
        
        getContentPane().add(geneInc[5], new org.netbeans.lib.awtextra.AbsoluteConstraints(400, 280, 120, 120));
        
        getContentPane().add(geneDec[5], new org.netbeans.lib.awtextra.AbsoluteConstraints(400, 400, 120, 120));
        
        lblGene7 = new JLabel("Gene 7 +/-:");
        getContentPane().add(lblGene7, new org.netbeans.lib.awtextra.AbsoluteConstraints(530, 0, 120, 20));

        getContentPane().add(geneInc[6], new org.netbeans.lib.awtextra.AbsoluteConstraints(530, 20, 120, 120));
        
        getContentPane().add(geneDec[6], new org.netbeans.lib.awtextra.AbsoluteConstraints(530, 140, 120, 120));
        
        lblGene8 = new JLabel("Gene 8 +/-:");
        getContentPane().add(lblGene8, new org.netbeans.lib.awtextra.AbsoluteConstraints(530, 260, 120, 20));
        
        getContentPane().add(geneInc[7], new org.netbeans.lib.awtextra.AbsoluteConstraints(530, 280, 120, 120));
        
        getContentPane().add(geneDec[7], new org.netbeans.lib.awtextra.AbsoluteConstraints(530, 400, 120, 120));
        
        for (int i=0; i<biomorph.getNoOfGenes(); i++) {
            final int j = i;
            geneInc[i].addMouseListener(new MouseAdapter() {
                public void mousePressed(MouseEvent e) {
                    setParentDrawChilds(geneInc[j].getGenome());

                    for (int k=0; k<parent.getGenome().getNoOfGenes(); k++) {
                        tabParent.setValueAt(((Integer)parent.getGenome().getGeneAt(k)).toString(),0,k);
                    }
                    
                    for (int k=0; k<parent.getGenome().getNoOfGenes(); k++) {
                        tabChild.setValueAt(((Integer)geneInc[j].getGenome().getGeneAt(k)).toString(),0,k);
                    }
                    
                }
                public void mouseEntered(MouseEvent e) {
                    for (int k=0; k<parent.getGenome().getNoOfGenes(); k++) {
                        tabChild.setValueAt(((Integer)geneInc[j].getGenome().getGeneAt(k)).toString(),0,k);
                    }
                    selectCellOfTable(tabChild, j);
                }
                public void mouseExited(MouseEvent e) {
                    clearGenomeTable(tabChild, new Genome());
                }
            });
            
            geneDec[i].addMouseListener(new MouseAdapter() {
                public void mousePressed(MouseEvent e) {
                    setParentDrawChilds(geneDec[j].getGenome());

                    for (int k=0; k<parent.getGenome().getNoOfGenes(); k++) {
                        tabParent.setValueAt(((Integer)parent.getGenome().getGeneAt(k)).toString(),0,k);
                    }
                    
                    for (int k=0; k<parent.getGenome().getNoOfGenes(); k++) {
                        tabChild.setValueAt(((Integer)geneDec[j].getGenome().getGeneAt(k)).toString(),0,k);
                    }
                    
                }
                public void mouseEntered(MouseEvent e) {
                    for (int k=0; k<parent.getGenome().getNoOfGenes(); k++) {
                        tabChild.setValueAt(((Integer)geneDec[j].getGenome().getGeneAt(k)).toString(),0,k);
                    }
                    selectCellOfTable(tabChild, j);
                }
                public void mouseExited(MouseEvent e) {
                    clearGenomeTable(tabChild, new Genome());
                }
            });
        }

        reset = new JButton("Reset");
        Font font = reset.getFont().deriveFont(10.0f);
        reset.setFont(font);
        getContentPane().add(reset, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 230, 62, 20));
        
        reset.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                Genome defBiomorph = new Genome();
                setParentDrawChilds(defBiomorph);
                setGenomeTable(tabParent, defBiomorph);
            }
        });
        
        random = new JButton("Rand.");
        random.setFont(font);
        getContentPane().add(random, new org.netbeans.lib.awtextra.AbsoluteConstraints(68, 230, 62, 20));
        
        random.addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent e) {
                Genome randBiomorph = new Genome();
                randBiomorph.randomizeGenome();
                setParentDrawChilds(randBiomorph);
                setGenomeTable(tabParent, randBiomorph);
            }
        });
    }
    
    private void clearGenomeTable(JTable jt, Genome biomorph) {
        for (int k=0; k < biomorph.getNoOfGenes(); k++) {
            jt.setValueAt("",0,k);
        }
    }
    
    private void setGenomeTable(JTable jt, Genome biomorph) {
        for (int k=0; k < biomorph.getNoOfGenes(); k++) {
            jt.setValueAt(((Integer)biomorph.getGeneAt(k)).toString(),0,k);
        }
    }
    
    private void selectCellOfTable(JTable jt, int position) {
        jt.setColumnSelectionInterval(position,position);
    }
    
    private void setParentDrawChilds(Genome biomorph) {
        parent.setGenome(biomorph);
        parent.repaint();
        
        for (int i=0; i<biomorph.getNoOfGenes(); i++) {
            try {
                Genome increased = biomorph.clone();
                Genome decreased = biomorph.clone();
                
                increased.increaseGene(i);
                decreased.decreaseGene(i);
                
                geneInc[i].setGenome(increased);
                geneDec[i].setGenome(decreased);
                geneInc[i].repaint();
                geneDec[i].repaint();
                
            } catch (CloneNotSupportedException e) {
                throw new java.lang.IllegalStateException("Genomes could'nt be cloned.");
            }
        }
    }
    
    public void init() {
        // Force SwingApplet to come up in the System L&F
        String laf = UIManager.getSystemLookAndFeelClassName();
        try {
            // UIManager.setLookAndFeel(laf);
            // If you want the Cross Platform L&F instead, comment out the above line and uncomment the following:
            UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
        } catch (UnsupportedLookAndFeelException exc) {
            System.err.println("Warning: UnsupportedLookAndFeel: " + laf);
        } catch (Exception exc) {
            System.err.println("Error loading " + laf + ": " + exc);
        }
        getContentPane().setBackground(java.awt.Color.WHITE);
        getContentPane().setSize(670,530);
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());
        
        drawGUI();
    }
}
